var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "event-mailer-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function storeSubParameter(path,value)
{
	Property.setProperty('values/' + path, value);
	Property.setFlag('values/' + path, 'ARCHIVE', true);
}

function storeValue(sParameterString)
{
	var oParameterObject=JSON.parse(unescape(sParameterString));
	var idValue=oParameterObject.id;
	if (idValue==null)
	{
		idValue=1;
		var oParameterBase=Property.getNode("values");
		if (oParameterBase!=null)
		{
			var oParameterArray=oParameterBase.getChildren();
			if (oParameterArray!=null)
			{	
				for (var iIndex=0;iIndex<oParameterArray.length;iIndex++)
				{
					var iNodeName=parseInt(oParameterArray[iIndex].getName(),10);
					if (idValue<=iNodeName)
						idValue=iNodeName+1;
				}
			}
		}		
	}
	
	var baseNode = Property.getNode('values');
	try {
		if (baseNode!=null)
			Property.removeChild(""+idValue);
	}
	catch (e){}
	
	storeSubParameter( idValue + '/name', oParameterObject.name);
	storeSubParameter( idValue + '/id', idValue);
	if (oParameterObject.defaultFooter==null)
		storeSubParameter( idValue + '/defaultFooter', false);
	else
		storeSubParameter( idValue + '/defaultFooter', oParameterObject.defaultFooter);
	storeSubParameter( idValue + '/message/messageType', oParameterObject.message.messageType);
	if (oParameterObject.message.messageType=="email") {
		storeSubParameter( idValue + '/message/receiver', oParameterObject.message.receiver);
		storeSubParameter( idValue + '/message/subject', oParameterObject.message.subject);
		storeSubParameter( idValue + '/message/messageBody', oParameterObject.message.message);
	}
	for (var iIndex=0;iIndex<oParameterObject.triggers.length;iIndex++)
	{
		var sSubpath=idValue + '/triggers/' + (iIndex + 1) + "/";		
		storeSubParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type);
		switch(oParameterObject.triggers[iIndex].type) {
			case 'zone-scene':
				storeSubParameter(sSubpath + "zone" , oParameterObject.triggers[iIndex].zone);
				storeSubParameter(sSubpath + "group" , oParameterObject.triggers[iIndex].group);
				storeSubParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene);
				storeSubParameter(sSubpath + "dsid" , -1);
				break;
			case 'device-msg':
				storeSubParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid);
				storeSubParameter(sSubpath + "msg" , oParameterObject.triggers[iIndex].msg);
				break
			case 'device-scene':
				storeSubParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid);
				storeSubParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene);
				break;
			case 'custom-event':
				storeSubParameter(sSubpath + "event" , oParameterObject.triggers[iIndex].event);
				break;
            case 'device-sensor':
                storeSubParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid);
                storeSubParameter(sSubpath + "evt" , oParameterObject.triggers[iIndex].evt);
                break;
		}
	}
    Property.store();
    updateTriggerRegistration(Property.getNode('values/' + idValue));
}

function updateTriggerRegistration(oChildNode){
    var oParameter={actions:'execute'};
    lInfo.logln("EM-Config Set Trigger " + oChildNode.getPath());
    registerTrigger(oChildNode.getPath(),'event-mailer',oParameter)    
}

function updateAllTrigger() {
    Property.load();
    var baseNode = Property.getNode('values');
    if (baseNode == null) {
        lInfo.logln("EM-Config update all trigger : no entries");     
        return;
    }
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        lInfo.logln("EM-Config Set Trigger" + iIndex);     
        var oChildNode = oArrayNode[iIndex];
        updateTriggerRegistration(oChildNode);
    }
}

if (raisedEvent.name == 'event-mailer') {
	lInfo.logln("event-mailer param action " + raisedEvent.parameter.actions);
	if (raisedEvent.parameter.actions=='save')
	{
	    lInfo.logln("event-mailer param value " + raisedEvent.parameter.value);		
		storeValue(raisedEvent.parameter.value);
		Property.store();
		var evt = new Event("event-mailer-saved",{});			
		evt.raise();
	}
	if (raisedEvent.parameter.actions=='enable')
	{
	    lInfo.logln("event-mailer enable value " + raisedEvent.parameter.id);	
	    storeSubParameter(raisedEvent.parameter.id + '/conditions/enabled', true);
		Property.store();
		var evt = new Event("event-mailer-saved",{});			
		evt.raise();
	}
	if (raisedEvent.parameter.actions=='disable')
	{
	    lInfo.logln("event-mailer disable value " + raisedEvent.parameter.id);		
	    storeSubParameter(raisedEvent.parameter.id + '/conditions/enabled', false);
		Property.store();
		var evt = new Event("event-mailer-saved",{});			
		evt.raise();
	}	
	if (raisedEvent.parameter.actions=='delete')
	{
	    lInfo.logln("event-mailer delete value " + raisedEvent.parameter.id);		
		
		var baseNode = Property.getNode('values');
		if (baseNode!=null)
			baseNode.removeChild( raisedEvent.parameter.id);
		Property.store();
		var evt = new Event("event-mailer-saved",{});			
		evt.raise();
	}		
    if (raisedEvent.parameter.actions == 'updateTrigger') {
        lInfo.logln("EM-Config updateTrigger");     
        updateAllTrigger();
    }
} else if (raisedEvent.name == 'running') {
	Property.load();
	checkAndUpdateData();
	updateAllTrigger();
}
